<template>
  <ObForm :form-data="formData">
    <div class="row">
      <div class="col-xs-8 flex">
        <div class="route-icon">
          <i
            style="font-size:28px; color:#0242AD"
            class="icon tractor-semi-trailer-refrizhirator-tent-b"
          ></i>
        </div>
        <div class="route-info">
          <div class="__way">{{ data.departureLocation.title || 'Не указано' }} → {{ data.arrivalLocation.title || 'Не указано' }}</div>
          <div class="__item" v-if="data.service">
            {{ data.service.resourceSpeciesTitle }}
            {{ data.service.resourceSubtypeTitle }}
            {{ data.service.resourcePatternParameter }}
          </div>
        </div>
      </div>
      <div class="col-xs-4">
        <span class="price-tip">
          Все цены
          <br />указаны без НДС
        </span>
      </div>
    </div>

    <div class="row">
      <ve-histogram
        :extend="chartExtend"
        :data="chartData"
        :loading="isAveragePriceChartLoading"
        height="250px"
        width="100%"
      ></ve-histogram>
    </div>

    <div class="row">
      <div class="col-xs-4">
        <div>
          <ob-input
            label="Усредненный тариф"
            :type="stage==='—' ? 'text' : 'money:2'"
            subTitle="₽"
            :value="stage"
            disabled
          />
        </div>
      </div>
      <div class="col-xs-4">
        <div>
          <ob-input
            label="Цена за км"
            subTitle="₽/км"
            :type="priceKm==='—' ? 'text' : 'money:2'"
            :value="priceKm"
            disabled
          />
        </div>
      </div>
      <div class="col-xs-4">
        <div>
          <ob-input label="Расстояние" subTitle="км" type="text" :value="distance" disabled />
        </div>
      </div>
    </div>

    <div class="row average-price-calculate">
      <h3 class="modal-section-title">Расчет усредненного тарифа (с учетом округления)</h3>

      <formula-view v-if="!!data.averaged_price" :items="averagePriceFormulaData" />
    </div>

    <ob-modal
      ref="viewHistory"
      title="История изменения БЦ"
      size="medium"
      custom-class="modal-medium"
      :is-read-only="true"
      :is-show-controls="true"
    >
      <history-modal />
    </ob-modal>
  </ObForm>
</template>

<script>
import { mapGetters, mapActions } from 'vuex';

import ObForm from 'common-components/src/obComponents/obForm';
import ObInput from 'common-components/src/obComponents/obInput';
import ObModal from 'common-components/src/obComponents/obModal';

import FormulaView from '../../DynamicFormula';
import HistoryModal from './HistoryModal';
import getAverageRateFormula from './constants/averageFormula';
import { formatKopeykiToRubli } from '@/pages/basePricesPage/utils';

export default {
  name: 'AverageRateModal',
  components: {
    ObForm,
    ObInput,
    FormulaView,
    HistoryModal,
    ObModal,
  },
  props: {
    data: {
      type: Object,
      default: () => {},
    },
  },
  data() {
    this.chartExtend = {
      yAxis: {
        axisLabel: {
          formatter: val => `${formatKopeykiToRubli(val, 1)} ₽`,
        },
      },
    };

    return {
      chartObj: {},
      chartData: {
        columns: ['date', 'Усредненный тариф'],
        rows: [],
      },
      formData: {
        serviceUnits: [],
      },
      averagePriceFormulaData: [],
    };
  },
  methods: {
    ...mapActions({
      getAveragePriceFormula: 'base_prices/getAveragePriceFormula',
      getAveragePriceChart: 'base_prices/getAveragePriceChart',
    }),
  },
  watch: {
    averagePriceFormula: function(val) {
      this.averagePriceFormulaData = getAverageRateFormula(val);
    },
    averagePriceChart: function(val) {
      if (val && val.length) {
        val.forEach(row => {
          this.chartObj[row.date] = {
            ...(this.chartObj[row.date] ? this.chartObj[row.date] : {}),
            'Усредненный тариф': row.price_value,
            date: row.date,
          };
        });

        this.chartData.rows = Object.values(this.chartObj);
      }
    },
  },
  computed: {
    ...mapGetters({
      averagePriceChart: 'base_prices/averagePriceChart',
      isAveragePriceChartLoading: 'base_prices/isAveragePriceChartLoading',
      averagePriceFormula: 'base_prices/averagePriceFormula',
      isAveragePriceFormulaLoading: 'base_prices/isAveragePriceFormulaLoading',
    }),
    averageData() {
      return this.data.averaged_price || {};
    },
    distance() {
      return this.averageData.distance || '—';
    },
    stage() {
      return this.averageData.price_stage ? this.averageData.price_stage : '—';
    },
    priceKm() {
      return this.averageData.price_km ? this.averageData.price_km : '—';
    },
  },
  mounted() {
    const { averaged_price, uuid } = this.data;

    if (averaged_price && averaged_price.uuid) {
      this.getAveragePriceFormula(averaged_price.uuid);
    }

    if (uuid) {
      this.getAveragePriceChart(uuid);
    }
  },
};
</script>

<style lang="scss" scoped>
$cobalt-black: #191e32;
$shale-gray: #474b5b;
$gray-slate: #737682;

@import '~common-components/src/static/css/mixins';

.modal-section-title {
  @include font-mixin(16px, 20px, 700, $cobalt-black, 0.4px);
  margin: 10px 0;
}

.flex {
  display: flex;
  align-items: center;
  .route-icon {
    margin-right: 13px;
  }
  .route-info {
    @include font-mixin(12px, 14px, 400, $cobalt-black, 0.4px);
    text-transform: uppercase;
  }
}

.price-tip {
  display: block;
  margin-left: auto;
  @include font-mixin(12px, 14px, 400, $gray-slate, 0.4px);
  text-transform: uppercase;
  text-align: right;
}

.average-price-calculate {
  display: flex;
  flex-direction: column;
}
</style>
